function xr = Rotate(x,Q)
% Uses the quaternion q to rotate vector x

if (size(x) == [1 3] | size(x) == [3 1]) & (size(Q) == [1 4] | size(Q) == [4 1])
    if size(x) == [1 3]
        x = x';
    end
    if size(Q) == [1 4]
        Q = Q';
    end
    
    xr = 2*Q(2:4)*dot(Q(2:4),x) + Q(1)^2*x + 2*Q(1)*cross(Q(2:4), x) - ...
        x*dot(Q(2:4), Q(2:4));
else
    error('Wrong dimension of vector x or quaternion q');
end