#include "matrix.h"

void mexFunction(int nlhs, mxArray *plhs[], int rhs, mxArray *prhs[])
{
    double *x;
    double *y;
    double *z;
    
    /* Check number of prhs */
    if (rhs != 2)
        mexErrMsgTxt("Number of input arguments must be two!");
    
    if (mxGetM(prhs[0])*mxGetN(prhs[0]) != 3)
        mexErrMsgTxt("Input vector must have dimension 1x3 or 3x1!");
    if (mxGetM(prhs[1])*mxGetN(prhs[1]) != 3)
        mexErrMsgTxt("Input vector must have dimension 1x3 or 3x1!");
    
    plhs[0] = mxCreateDoubleMatrix(3,1,mxREAL);
    x = mxGetPr(prhs[0]);
    y = mxGetPr(prhs[1]);
    z = mxGetPr(plhs[0]);
    z[0] = x[1]*y[2] - x[2]*y[1];
    z[1] = x[2]*y[0] - x[0]*y[2];
    z[2] = x[0]*y[1] - x[1]*y[0];
}
