function R = getRot(q)
% Returns the rotation matrix from a given 4-dimensional quaternion q

if size(q) == [1 4] | size(q) == [4 1]
    R = [1-2*(q(3)^2+q(4)^2), 2*q(2)*q(3)-2*q(1)*q(4), 2*q(1)*q(3)+2*q(2)*q(4);...
        2*q(2)*q(3)+2*q(1)*q(4), 1-2*(q(2)^2+q(4)^2), -2*q(1)*q(2)+2*q(3)*q(4);...
        -2*q(1)*q(3)+2*q(2)*q(4), 2*q(1)*q(2)+2*q(3)*q(4), 1-2*(q(2)^2+q(3)^2)];
else
    error('Wrong type of input, q must be 4-dimensional');
end