#include "matrix.h"

/* z = getSTAR2(x)
 * Get cross product matrix of vector x */
void mexFunction(int lhs, mxArray *plhs[], int rhs, mxArray *prhs[])
{
    double *x;
    double *z;
    
    /* Check for correct input arguments */
    if (rhs != 1)
        mexErrMsgTxt("Number of input arguments must be 1");
    if (mxGetM(prhs[0])*mxGetN(prhs[0]) != 3)
        mexErrMsgTxt("Wrong dimension of input argument");
    
    plhs[0] = mxCreateDoubleMatrix(3,3,mxREAL);
    x = mxGetPr(prhs[0]);
    z = mxGetPr(plhs[0]);
    
    z[0] = 0;
    z[1] = x[2];
    z[2] = -x[1];
    z[3] = -x[2];
    z[4] = 0;
    z[5] = x[0];
    z[6] = x[1];
    z[7] = -x[0];
    z[8] = 0;
}
